<?php
/*******************************************************************************

XBMC Status- und Steuerungsskript (IP-Symcon 2.2 / 12.03.2010)
==============================================================

Dieses Skript legt bei Ausfhrung automatisch alle ntigen Objekte zur
Kommunikation und Darstellung an. Es ist vorher lediglich die Konfiguration
anzupassen in dieser Datei und im XBMC anzupassen. XBMC sollte whrend des
initialen Aufrufs aktiviert und konfiguriert sein.


Unter XBMC sind zur Kommunikation folgende Einstellungen unter
System -> Einstellungen -> Netzwerk -> Server zu setzen:

- Webserver aktivieren: ja
- Webserver Port: beliebiger freier Port, z.B. 8080
- Webserver Benutzername: beliebig
- Webserver Passwort: beliebig
- Freigabe fr Fernsteuerprogramme auf diesem Rechner: ja


Dieses Skript kann von einem anderen Skript aus gestartet werden, um im XBMC
eine Benachrichtigung anzuzeigen:

IPS_RunScriptEx(SkriptID, array(
	"IPS_SENDER" => "SendXBMCNotification",
	"Title" => "Nachrichtentitel",
	"Message" => "Der Nachrichtentext",
	"Duration" => 5 // Angabe in Sekunden
));

*******************************************************************************/

// ----- Konfiguration ---------------------------------------------------------

$config = array();
$config['Name'] = "XBMC";				// Name dieses XBMCs
$config['Host'] = "192.168.1.100";		// Hostname oder IP des XBMC-PCs
$config['UDPPort'] = 8278;				// XBMC-UDP-Port (Standard: 8278)
$config['WebPort'] = 8080;				// XBMC "Webserver Port"
$config['WebUser'] = "xbmc";			// XBMC "Webserver Benutzername"
$config['WebPassword'] = "test";		// XBMC "Webserver Passwort"
$config['WebTimeout'] = 5;				// Timeout fr Webserveranfragen
$config['UpdateInterval'] = 10;			// Update-Intervall fr die Filmposition

// ----- Programmcode (nicht verndern) ----------------------------------------

$object = IPS_GetObject($IPS_SELF);
$parentID = $object['ParentID'];

function startBroadcasting ()
{
	global $config;
	sendWebRequest("SetBroadcast(1;".$config['UDPPort'].")");
}

function sendNotification ($title = "", $message = "", $duration = 5)
{
	startBroadcasting();
	sendWebRequest("ExecBuiltIn(Notification(".$title.",".$message.",".($duration * 1000)."))");
}

function sendWebRequest ($command)
{
	global $config;
	return @Sys_GetURLContentEx('http://'.$config['Host'].':'.$config['WebPort'].'/xbmcCmds/xbmcHttp?command='.rawurlencode($command), array("AuthUser"=>$config['WebUser'],"AuthPass"=>$config['WebPassword'],"Timeout"=>$config['WebTimeout'] * 1000));
}

if ($IPS_SENDER == "Execute")
{
	IPS_SetHidden($IPS_SELF, true);
	IPS_SetName($IPS_SELF, $config['Name']." Data Handler");

	$profile = @IPS_GetVariableProfile("XBMC_Play_State");
	if ($profile === false)
	{
		IPS_CreateVariableProfile("XBMC_Play_State", 1);
		IPS_SetVariableProfileValues("XBMC_Play_State", 0, 4, 0);
		IPS_SetVariableProfileIcon("XBMC_Play_State", "ArrowRight");
		IPS_SetVariableProfileAssociation("XBMC_Play_State", 0, "Rewind", "");
		IPS_SetVariableProfileAssociation("XBMC_Play_State", 1, "Play", "");
		IPS_SetVariableProfileAssociation("XBMC_Play_State", 2, "Pause", "");
		IPS_SetVariableProfileAssociation("XBMC_Play_State", 3, "Stop", "");
		IPS_SetVariableProfileAssociation("XBMC_Play_State", 4, "Fast Forward", "");
	}

	$profile = @IPS_GetVariableProfile("XBMC_Position");
	if ($profile === false)
	{
		IPS_CreateVariableProfile("XBMC_Position", 1);
		IPS_SetVariableProfileValues("XBMC_Position", 0, 100, 1);
		IPS_SetVariableProfileIcon("XBMC_Position", "Gauge");
		IPS_SetVariableProfileText("XBMC_Position", "", " %");
	}

	$parentObject = IPS_GetObject($parentID);
	if ($parentObject['ObjectType'] !== 1)
	{
		$instanceID = IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}");
		IPS_SetParent($instanceID, $parentID);
		$parentID = $instanceID;
		IPS_SetParent($IPS_SELF, $parentID);
		IPS_SetName($instanceID, $config['Name']);
	}

	$statusID = CreateVariableByName($parentID, "Status", 1, "XBMC_Play_State");
	SetValue($statusID, 3);
	IPS_SetVariableCustomAction($statusID, $IPS_SELF);
	$titleID = CreateVariableByName($parentID, "Titel", 3, "~TextBox");
	SetValue($titleID, "-");
	$positionID = CreateVariableByName($parentID, "Position", 1, "XBMC_Position");
	SetValue($positionID, 0);
	IPS_SetVariableCustomAction($positionID, $IPS_SELF);

	$thumbID = @IPS_GetMediaIDByName("Cover", $parentID);
	if ($thumbID === false)
	{
		$thumbID = IPS_CreateMedia(1);
		IPS_SetParent($thumbID, $parentID);
		IPS_SetName($thumbID, "Cover");
	}
	IPS_SetMediaFile($thumbID, "media\\xbmcCover".$parentID.".img", false);
	copy("..\webfront\\user\\xbmc\\defaultCover.png", "..\\media\\xbmcCover".$parentID.".img");
	IPS_SendMediaEvent($thumbID);

	$socketID = @IPS_GetInstanceIDByName($config['Name']." Socket", 0);
	if ($socketID === false)
	{
		$socketID = IPS_CreateInstance("{82347F20-F541-41E1-AC5B-A636FD3AE2D8}");
		IPS_SetName($socketID, $config['Name']." Socket");
	}
	USCK_SetHost($socketID, $config['Host']);
	USCK_SetPort($socketID, $config['UDPPort']);
	$bindIPs = USCK_GetIPs($socketID);
	if (count($bindIPs) > 0) { USCK_SetBindIPAddress($socketID, $bindIPs[0]); }
	USCK_SetBindPort($socketID, $config['UDPPort']);
	USCK_SetOpen($socketID, true);
	IPS_ApplyChanges($socketID);

	$rvID = @IPS_GetInstanceIDByName($config['Name']." Register Variable", $parentID);
	if ($rvID === false)
	{
		$rvID = IPS_CreateInstance("{F3855B3C-7CD6-47CA-97AB-E66D346C037F}");
		IPS_SetParent($rvID, $parentID);
		IPS_SetName($rvID, $config['Name']." Register Variable");
	}
	RegVar_SetRXObjectID($rvID, $IPS_SELF);
	IPS_ConnectInstance($rvID, $socketID);
	IPS_ApplyChanges($rvID);

	$msID = @IPS_GetScriptIDByName("Filmauswahl", $parentID);
	if ($msID === false)
	{
		$msID = IPS_CreateScript(0);
		$handle = fopen("xbmcMovieSelect".$parentID.".ips.php", "w");
		fwrite($handle, "<iframe src=\"user/xbmc/xbmc.php?Host=".$config['Host']."&WebPort=".$config['WebPort']."&WebUser=".$config['WebUser']."&WebPassword=".$config['WebPassword']."\" border=\"0\" frameborder=\"0\" style=\"top: 0pt; bottom: 0pt; left: 0pt; right: 0pt; width: 100%; height: 100%;\" />");
		IPS_SetScriptFile($msID, "xbmcMovieSelect".$parentID.".ips.php");
		IPS_SetParent($msID, $parentID);
		IPS_SetName($msID, "Filmauswahl");
	}

	IPS_SetScriptTimer($IPS_SELF, 0);

	startBroadcasting();
	loadCurrentStatus();
}
else if ($IPS_SENDER == "RegisterVariable")
{
	$statusID = IPS_GetVariableIDByName("Status", $parentID);
	$titleID = IPS_GetVariableIDByName("Titel", $parentID);
	$positionID = IPS_GetVariableIDByName("Position", $parentID);

	$event = strip_tags($IPS_VALUE);
	$eventType = (int)substr($event, -1);
	$event = substr($event, 0, -2);
	$eventParts = explode(":", $event);

	switch ($eventParts[0])
	{
		case "StartUp":
		case "OnPlayBackStopped":
		case "OnPlayBackEnded":
			SetValue($statusID, 3);
			SetValue($titleID, "-");
			SetValue($positionID, 0);
			getCover("");
			IPS_SetScriptTimer($IPS_SELF, 0);
			break;

		case "OnPlayBackStarted":
			loadCurrentStatus();
			SetValue($statusID, 1);
			IPS_SetScriptTimer($IPS_SELF, $config['UpdateInterval']);
			break;

			case "OnPlayBackResumed":
			SetValue($statusID, 1);
			break;

			case "OnPlayBackPaused":
			SetValue($statusID, 2);
			break;

		case "MediaChanged":
			$title = utf8_decode($eventParts[2]);
			SetValue($statusID, 1);
			SetValue($titleID, $title);
			IPS_SetScriptTimer($IPS_SELF, $config['UpdateInterval']);

			for ($i = 0; $i < 10; $i++)
			{
				$playing = getCurrentlyPlaying();
				if (count($playing) > 5)
				{
					if (isset($playing['Thumb']))
					{
						getCover($playing['Thumb']);
					}
					break;
				}
				else
				{
					sleep(1);
				}
			}
			break;
	}
}
else if ($IPS_SENDER == "WebFront")
{
	$statusID = IPS_GetVariableIDByName("Status", $parentID);
	$positionID = IPS_GetVariableIDByName("Position", $parentID);

	$data = "";

	switch ($IPS_VARIABLE)
	{
		case $statusID:
			switch ($IPS_VALUE)
			{
				case 0:
					$playing = getCurrentlyPlaying();
					if (isset($playing['Percentage']))
					{
						$position = (int)$playing['Percentage'];
						$data = sendWebRequest("SeekPercentage(".max(0, $position - 1).")");
						sleep(1);
						loadCurrentStatus();
					}
					break;

				case 1:
					$data = sendWebRequest("Pause()");
					break;

				case 2:
					$data = sendWebRequest("Pause()");
					break;

				case 3:
					$data = sendWebRequest("Stop()");
					break;

				case 4:
					$playing = getCurrentlyPlaying();
					if (isset($playing['Percentage']))
					{
						$position = (int)$playing['Percentage'];
						$data = sendWebRequest("SeekPercentage(".min(100, $position + 1).")");
						sleep(1);
						loadCurrentStatus();
					}
					break;
			}
			break;

		case $positionID:
			$data = sendWebRequest("SeekPercentage(".$IPS_VALUE.")");
			sleep(1);
			loadCurrentStatus();
			break;
	}
	if ($data === false)
	{
		echo "XBMC wird nicht ausgefhrt!";
	}
}
else if ($IPS_SENDER == "TimerEvent")
{
	startBroadcasting();
	loadCurrentStatus();
}

function loadCurrentStatus ()
{
	global $parentID, $IPS_SELF;

	$statusID = IPS_GetVariableIDByName("Status", $parentID);
	$titleID = IPS_GetVariableIDByName("Titel", $parentID);
	$positionID = IPS_GetVariableIDByName("Position", $parentID);

	$titletext = "-";
	$position = 0;
	$status = 3;

	$playing = getCurrentlyPlaying();

	if ($playing === false)
	{
		IPS_SetScriptTimer($IPS_SELF, 0);
		getCover("");
	}
	else
	{
		if (isset($playing['Title']))
		{
			$titletext = $playing['Title']."\n(".$playing['Time'].' / '.$playing['Duration'].')';
		}
		else if (isset($playing['Filename']) && $playing['Filename'] !== "[Nothing Playing]")
		{
			$titletext = $playing['Filename']."\n(".$playing['Time'].' / '.$playing['Duration'].')';
		}

		if (isset($playing['Percentage'])) { $position = (int)$playing['Percentage']; }

		if (isset($playing['PlayStatus']))
		{
			switch ($playing['PlayStatus'])
			{
				case "Playing": $status = 1; break;
				case "Paused": $status = 2; break;
			}
		}
	}

	SetValueString($titleID, $titletext);
	SetValueInteger($positionID, $position);
	SetValueInteger($statusID, $status);
}

function getCurrentlyPlaying ()
{
	$content = sendWebRequest("GetCurrentlyPlaying()");
	if ($content === false) { return $content; }

	$content = utf8_decode($content);
	$content = str_replace("<html>", "", $content);
	$content = str_replace("</html>", "", $content);
	$content = str_replace("\n", "", $content);
	$lines = explode("<li>", $content);

	$info = array();
	foreach ($lines as $line)
	{
		$pos = strpos($line, ":");
		$key = substr($line, 0, $pos);
		$value = substr($line, $pos + 1);
		if ($key != "")
		{
			$info[$key] = $value;
		}
	}

	return $info;
}

function getCover ($url)
{
	global $parentID;

	$thumbID = IPS_GetMediaIDByName("Cover", $parentID);

	$filename = "media\\xbmcCover".$parentID.".img";

	$useDefaultCover = true;

	if (substr($url, 0, 7) == "special")
	{
		for ($i = 0; $i < 10; $i++)
		{
			$imageData = sendWebRequest("FileDownload(".$url.";bare)");

			if ($image = @imagecreatefromstring(base64_decode($imageData)))
			{
				$width = imagesx($image);
				$height = imagesy($image);
				$newHeight = 300;
				$newWidth = round(($width * $newHeight) / $height);

				$imageResized = imagecreatetruecolor($newWidth, $newHeight);
				imagecopyresampled($imageResized, $image, 0, 0, 0, 0, $newWidth, $newHeight, $width, $height);
				imagejpeg($imageResized, "..\\".$filename, 85);

				imagedestroy($image);
				imagedestroy($imageResized);

				$useDefaultCover = false;

				break;
			}
			else
			{
				sleep(1);
			}
		}
	}

	if ($useDefaultCover)
	{
		copy("..\\webfront\\user\\xbmc\\defaultCover.png", "..\\".$filename);
	}
	IPS_SendMediaEvent($thumbID);
}

function CreateVariableByName ($id, $name, $type, $profile = "")
{
	global $IPS_SELF;
	$vid = @IPS_GetVariableIDByName($name, $id);
	if ($vid === false)
	{
		$vid = IPS_CreateVariable($type);
		IPS_SetParent($vid, $id);
		IPS_SetName($vid, $name);
		IPS_SetInfo($vid, "this variable was created by script #$IPS_SELF");
		if ($profile !== "") { IPS_SetVariableCustomProfile($vid, $profile); }
	}
	return $vid;
}
?>