<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<head>

<title>IP-Symcon WebFront XBMC-Interface</title>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Cache-Control" content="no-store, no-cache, must-revalidate" />
<meta http-equiv="Pragma" content="no-cache" />
<meta http-equiv="Expires" content="0" />

<link rel="icon" href="../../favicon.ico" type="image/x-icon" />

<script type="text/javascript" src="./../../dojo-release-1.4.1/dojo/dojo.js" djConfig=""></script>
<style type="text/css">@import "../default.css";</style>

<style type="text/css">
html, body { background: black; }
.movie
{
	font: normal 14px verdana;
	position: relative;
	margin: 10px 2px;
	padding: 10px;
	border: 1px solid #3b3b4d;
	height: 33px;
	border-radius: 8px;
	-moz-border-radius: 8px;
	-webkit-border-radius: 8px;
	overflow: hidden;
	white-space: nowrap;
}

.movie .description
{
	position: relative;
	height: 33px;
}

.movie .description .title, .movie .description .titleHigh
{
	font-size: 11pt;
	font-family: sans-serif;
	font-weight: bold;
}

.movie .description .titleHigh
{
	line-height: 33px;
}

.movie .description .subtext
{
	font-size: 9pt;
	font-family: sans-serif;
}

.movie .rating
{
	position: absolute;
	top:7px;
	right: 13px;
	width: 45px;
	text-align: center;
	font-size: 25pt;
	font-family: arial;
}

.movie .icons
{
	position: absolute;
	top:0;
	right: 75px;
	text-align: right;
}

.movie .icons img
{
	top: 4px;
	position: relative;
}
</style>

<script type="text/javascript">
dojo.require("dojox.string.sprintf");

var movieList = [];
var movieListSortMode = "sortTitle";

function getData (parameters, onload)
{
	var command = "";
	for (var i in parameters)
	{
		command += "&" + i + "=" + parameters[i];
	}
	
	dojo.xhrGet(
	{
<?php
	$Host = isset($_GET['Host']) ? $_GET['Host'] : "";
	$WebPort = isset($_GET['WebPort']) ? $_GET['WebPort'] : "";
	$WebUser = isset($_GET['WebUser']) ? $_GET['WebUser'] : "";
	$WebPassword = isset($_GET['WebPassword']) ? $_GET['WebPassword'] : "";
	
	echo "		url: \"xbmc.com.php?Host=".$Host."&WebPort=".$WebPort."&WebUser=".$WebUser."&WebPassword=".$WebPassword."\" + command,\n";
?>
		handleAs: "json",
		timeout: 30000,

		load: function (response, ioArgs)
		{
			if (onload)
			{
				onload(response);
			}
			
			return response;
		},

		error: function (response, ioArgs)
		{
			return response;
		}
	});
}

function renderMovieList ()
{
	var mlcContent = "";
	
	for (var i in movieList)
	{
		var movie = movieList[i];
		
		var icons = "<img src=\"" + movie.resolution + ".png\" />";
		var location = (movie.path + movie.file).replace(/ /g, "%20");
		var rating = (movie.rating > 0) ? dojox.string.sprintf("%.1f", movie.rating) : "-";
		var duration = movie.duration.substr(0, movie.duration.indexOf("min"));
		
		var subTextList = [];
		if (movie.year > 0)
		{
			subTextList.push(movie.year);
		}
		if (duration !== "")
		{
			subTextList.push(duration + " min");
		}
		if (movie.genre !== "")
		{
			subTextList.push(movie.genre);
		}
		
		var subText = subTextList.join(" - ");
		mlcContent += "<div class=\"movie\" onclick=\"playMovie('" + location.replace(/\\/g, "\\\\") + "');\"><div class=\"icons\">" + icons + "</div><div class=\"rating\">" + rating + "</div><div class=\"description\"><div class=\"title" + ((subText === "") ? "High" : "") + "\">" + movie.title + "</div>";		
		mlcContent += "<div class=\"subtext\">" + subText + "</div></div></div>";
	}
	
	var movieListContainer = dojo.byId("movieListContainer");
	movieListContainer.innerHTML = mlcContent;
}

var sortMovieBySortTitle = function (a, b)
{
	var arr = [a.sortTitle, b.sortTitle].sort();
	return arr[0] == b.sortTitle;
};

var sortMovieByRating = function (a, b)
{
	var result = b.rating - a.rating;
	if (result === 0) { result = sortMovieBySortTitle(a, b); }
	return result;
};

var sortMovieByYear = function (a, b)
{
	var result = b.year - a.year;
	if (result === 0) { result = sortMovieBySortTitle(a, b); }
	return result;
};

function sortMovieList (mode)
{
	movieListSortMode = mode;
	
	var sortFunction = null;
	
	switch (movieListSortMode)
	{
		case "sortTitle":
			sortFunction = sortMovieBySortTitle;
			break;
			
		case "rating":
			sortFunction = sortMovieByRating;
			break;
			
		case "year":
			sortFunction = sortMovieByYear;
			break;
	}
	
	movieList.sort(sortFunction);
	renderMovieList();
}

function getMovieList ()
{
	getData({"do": "getMovieList"}, function (content)
	{
		if (content.movies.error)
		{
			document.body.innerHTML = "<div style=\"text-align:center;color:red;font-weight:bold;\">" + content.movies.error + "</div>";
		}
		else
		{
			movieList = content.movies;
			sortMovieList(movieListSortMode);
		}
	});
}

function playMovie (location)
{
	getData({"do": "playMovie", "location": location}, null);
}

dojo.addOnLoad(function () { getMovieList(); });
</script>

</head>

<body>
<div style="font-size: 10pt; text-align:center;"><span onclick="sortMovieList('rating')">nach Bewertung</span> | <span onclick="sortMovieList('sortTitle')">nach Titel</span> | <span onclick="sortMovieList('year')">nach Jahr</span></div>
<div id="movieListContainer">lade...</div>
</body>

</html>